"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _1 = require(".");
class ClientFetch {
    constructor(client) {
        this.client = client;
    }
    me() {
        this.client.send({
            _type: _1.NetworkPacketType.GetMe,
            _auth: this.client.getAuth()
        });
        return this;
    }
    guilds() {
        this.client.send({
            _type: _1.NetworkPacketType.GetGuilds,
            _auth: this.client.getAuth()
        });
        return this;
    }
    channels(guild) {
        this.client.send({
            _type: _1.NetworkPacketType.GetChannels,
            _auth: this.client.getAuth(),
            guild: guild
        });
        return this;
    }
    allChannels() {
        const guilds = this.client.getGuilds();
        for (let guild of guilds.values()) {
            console.log(guild);
            this.channels(guild.id);
        }
        return this;
    }
    members(guild, pivot, count) {
        this.client.send({
            _type: _1.NetworkPacketType.GetMembers,
            _auth: this.client.getAuth(),
            guild: guild,
            pivot: pivot,
            count: count
        });
        return this;
    }
    member(guild, member) {
        this.client.send({
            _type: _1.NetworkPacketType.GetMember,
            _auth: this.client.getAuth(),
            guild: guild,
            member: member
        });
        return this;
    }
}
exports.default = ClientFetch;
