/// <reference types="node" />
import { EventEmitter } from "events";
import { Id } from "../client";
export declare type CollectionMapCallback<Type> = (value: Type, key: Id, collection: Collection<Type>) => any;
export declare type CollectionFilterCallback<Type> = (value: Type, key: Id, collection: Collection<Type>) => void;
export default class Collection<Type> extends Map<Id, Type> {
    readonly events: EventEmitter;
    constructor();
    map(callback: CollectionMapCallback<Type>, thisArg?: any): Array<Type>;
    set(key: Id, value: Type): this;
    filter(callback: CollectionFilterCallback<Type>, thisArg?: any): Collection<any>;
}
