"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const events_1 = require("events");
class Collection extends Map {
    constructor() {
        super();
        this.events = new events_1.EventEmitter();
    }
    map(callback, thisArg) {
        if (thisArg) {
            callback = callback.bind(thisArg);
        }
        const arr = new Array(this.size);
        let i = 0;
        for (const [key, value] of this) {
            arr[i++] = callback(value, key, this);
        }
        return arr;
    }
    set(key, value) {
        super.set(key, value);
        this.events.emit("set", key, value);
        return this;
    }
    // TODO: Return sub-type
    filter(callback, thisArg) {
        if (thisArg) {
            callback = callback.bind(thisArg);
        }
        const results = new Collection();
        for (const [key, value] of this) {
            if (callback(value, key, this)) {
                results.set(key, value);
            }
        }
        return results;
    }
}
exports.default = Collection;
