"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const collection_1 = __importDefault(require("./collections/collection"));
const network_actions_1 = require("./network/network-actions");
class InterceptorManager {
    static setInterceptor(type, interceptor) {
        const name = network_actions_1.getPacketEventName(type);
        if (InterceptorManager.interceptors.has(name)) {
            return false;
        }
        InterceptorManager.interceptors.set(name, interceptor);
        return true;
    }
    static getInterceptor(type) {
        const result = InterceptorManager.interceptors.get(network_actions_1.getPacketEventName(type));
        return result || null;
    }
}
InterceptorManager.interceptors = new collection_1.default();
exports.default = InterceptorManager;
