"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const network_actions_1 = require("../network/network-actions");
const __1 = require("..");
const interceptor_decorators_1 = __importDefault(require("../interceptor-decorators"));
class Master {
    static getTokenResponse(response, client) {
        if (response.state === network_actions_1.GetTokenResponseState.OK && response.token) {
            client.setToken(response.token, true);
            client.send({
                _auth: client.getAuth(),
                _type: network_actions_1.NetworkPacketType.GetMe
            });
        }
        return response.state;
    }
    static getMeResponse(response, client) {
        const firstTime = !client.getMe();
        client.setMe(response.user);
        if (firstTime) {
            client.emit("ready");
        }
        if (client.getMe() === undefined) {
            throw new Error("[Master.getMeResponse] Unexpected me to be undefined");
        }
        return client.getMe();
    }
    static getGuildsResponse(response, client) {
        if (response.guilds && response.guilds.length > 0) {
            const guilds = new __1.Collection();
            for (let i = 0; i < response.guilds.length; i++) {
                guilds.set(response.guilds[i].id, response.guilds[i]);
            }
            client.setGuilds(guilds);
        }
        return client.getGuilds();
    }
    static message(message, client) {
        client.addMessage(message.message);
        return message.message;
    }
    static getMembersResponse(response, client) {
        console.log("get members response", response);
        if (response.state === network_actions_1.GetMembersResponseState.OK && response.members && response.guild) {
            const memberCollection = new __1.Collection();
            for (let i = 0; i < response.members.length; i++) {
                memberCollection.set(response.members[i].user.id, response.members[i]);
            }
            client.setMembers(response.guild, memberCollection);
            return true;
        }
        return false;
    }
    static useInviteResponse(response, client) {
        if (response.state === network_actions_1.UseInviteResponseState.OK && response.guild) {
            client.setGuild(response.guild.id, response.guild);
            return response.guild;
        }
        return null;
    }
}
__decorate([
    interceptor_decorators_1.default(network_actions_1.NetworkPacketType.GetTokenResponse)
], Master, "getTokenResponse", null);
__decorate([
    interceptor_decorators_1.default(network_actions_1.NetworkPacketType.GetMeResponse)
], Master, "getMeResponse", null);
__decorate([
    interceptor_decorators_1.default(network_actions_1.NetworkPacketType.GetGuildsResponse)
], Master, "getGuildsResponse", null);
__decorate([
    interceptor_decorators_1.default(network_actions_1.NetworkPacketType.Message)
], Master, "message", null);
__decorate([
    interceptor_decorators_1.default(network_actions_1.NetworkPacketType.GetMembersResponse)
], Master, "getMembersResponse", null);
__decorate([
    interceptor_decorators_1.default(network_actions_1.NetworkPacketType.UseInviteResponse)
], Master, "useInviteResponse", null);
exports.default = Master;
