import User, { AvatarHash } from "./user";
import Channel from "./channels/channel";
import { Id } from "../client";
export interface GuildOptions {
    readonly id: Id;
    readonly createdAt: number;
    readonly icon?: AvatarHash;
    readonly name: string;
    readonly owner: GuildMember;
    readonly channels: Array<Channel>;
    readonly members: Array<GuildMember>;
}
export interface GuildMember {
    readonly nickname?: string;
    readonly user: User;
}
export default class Guild {
    readonly id: Id;
    readonly createdAt: number;
    readonly icon?: AvatarHash;
    readonly name: string;
    readonly owner: GuildMember;
    readonly channels: Array<Channel>;
    constructor(options: GuildOptions);
}
