import { Id } from "../client";
export declare type AvatarHash = string;
export declare enum UserState {
    Online = 0,
    Offline = 1,
    Idle = 2,
    DoNotDisturb = 3
}
export declare enum UserType {
    User = 0,
    Bot = 1,
    Admin = 2
}
export interface UserPresence {
    readonly state: UserState;
    readonly status?: string;
}
export interface UserOptions {
    readonly id: Id;
    readonly username: string;
    readonly discriminator: number;
    readonly type: UserType;
    readonly avatar?: AvatarHash;
    readonly presence: UserPresence;
}
export declare class User {
    readonly id: Id;
    readonly username: string;
    readonly discriminator: number;
    readonly type: UserType;
    readonly avatar?: AvatarHash;
    readonly presence: UserPresence;
    constructor(options: UserOptions);
}
export default User;
