"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var NetworkPacketType;
(function (NetworkPacketType) {
    NetworkPacketType[NetworkPacketType["GetToken"] = 0] = "GetToken";
    NetworkPacketType[NetworkPacketType["GetTokenResponse"] = 1] = "GetTokenResponse";
    NetworkPacketType[NetworkPacketType["GetMe"] = 2] = "GetMe";
    NetworkPacketType[NetworkPacketType["GetMeResponse"] = 3] = "GetMeResponse";
    NetworkPacketType[NetworkPacketType["Message"] = 4] = "Message";
    NetworkPacketType[NetworkPacketType["MessageSend"] = 5] = "MessageSend";
    NetworkPacketType[NetworkPacketType["MessageSendResponse"] = 6] = "MessageSendResponse";
    NetworkPacketType[NetworkPacketType["AuthResponse"] = 7] = "AuthResponse";
    NetworkPacketType[NetworkPacketType["CreateAccount"] = 8] = "CreateAccount";
    NetworkPacketType[NetworkPacketType["CreateAccountResponse"] = 9] = "CreateAccountResponse";
    NetworkPacketType[NetworkPacketType["CreateGuild"] = 10] = "CreateGuild";
    NetworkPacketType[NetworkPacketType["CreateGuildResponse"] = 11] = "CreateGuildResponse";
    NetworkPacketType[NetworkPacketType["UpdateGuild"] = 12] = "UpdateGuild";
    NetworkPacketType[NetworkPacketType["UpdateGuildResponse"] = 13] = "UpdateGuildResponse";
    NetworkPacketType[NetworkPacketType["TransferOwnership"] = 14] = "TransferOwnership";
    NetworkPacketType[NetworkPacketType["TransferOwnershipResponse"] = 15] = "TransferOwnershipResponse";
    NetworkPacketType[NetworkPacketType["GetGuild"] = 16] = "GetGuild";
    NetworkPacketType[NetworkPacketType["GetGuildResponse"] = 17] = "GetGuildResponse";
    NetworkPacketType[NetworkPacketType["CreateChannel"] = 18] = "CreateChannel";
    NetworkPacketType[NetworkPacketType["CreateChannelResponse"] = 19] = "CreateChannelResponse";
    NetworkPacketType[NetworkPacketType["GetChannels"] = 20] = "GetChannels";
    NetworkPacketType[NetworkPacketType["GetChannelsResponse"] = 21] = "GetChannelsResponse";
    NetworkPacketType[NetworkPacketType["GetMembers"] = 22] = "GetMembers";
    NetworkPacketType[NetworkPacketType["GetMembersResponse"] = 23] = "GetMembersResponse";
    NetworkPacketType[NetworkPacketType["GetMember"] = 24] = "GetMember";
    NetworkPacketType[NetworkPacketType["GetMemberResponse"] = 25] = "GetMemberResponse";
    NetworkPacketType[NetworkPacketType["UpdateMe"] = 26] = "UpdateMe";
    NetworkPacketType[NetworkPacketType["UpdateMeResponse"] = 27] = "UpdateMeResponse";
    NetworkPacketType[NetworkPacketType["DeleteGuild"] = 28] = "DeleteGuild";
    NetworkPacketType[NetworkPacketType["DeleteGuildResponse"] = 29] = "DeleteGuildResponse";
    NetworkPacketType[NetworkPacketType["GetGuilds"] = 30] = "GetGuilds";
    NetworkPacketType[NetworkPacketType["GetGuildsResponse"] = 31] = "GetGuildsResponse";
    NetworkPacketType[NetworkPacketType["UseInvite"] = 32] = "UseInvite";
    NetworkPacketType[NetworkPacketType["UseInviteResponse"] = 33] = "UseInviteResponse";
    NetworkPacketType[NetworkPacketType["GetInvite"] = 34] = "GetInvite";
    NetworkPacketType[NetworkPacketType["GetInviteResponse"] = 35] = "GetInviteResponse";
})(NetworkPacketType = exports.NetworkPacketType || (exports.NetworkPacketType = {}));
/* Special Packets */
class NetworkAction {
    constructor(type) {
        this._type = type;
    }
}
exports.NetworkAction = NetworkAction;
class AuthAction extends NetworkAction {
    constructor(type, auth) {
        super(type);
        this._auth = auth;
    }
}
exports.AuthAction = AuthAction;
var AuthResponseState;
(function (AuthResponseState) {
    AuthResponseState[AuthResponseState["OK"] = 0] = "OK";
    AuthResponseState[AuthResponseState["InvalidToken"] = 1] = "InvalidToken";
    AuthResponseState[AuthResponseState["TokenExpired"] = 2] = "TokenExpired";
})(AuthResponseState = exports.AuthResponseState || (exports.AuthResponseState = {}));
/* General Packets */
var GetTokenResponseState;
(function (GetTokenResponseState) {
    GetTokenResponseState[GetTokenResponseState["OK"] = 0] = "OK";
    GetTokenResponseState[GetTokenResponseState["InvalidCredentials"] = 1] = "InvalidCredentials";
    GetTokenResponseState[GetTokenResponseState["AccountDisabled"] = 2] = "AccountDisabled";
})(GetTokenResponseState = exports.GetTokenResponseState || (exports.GetTokenResponseState = {}));
var MessageSendResponseState;
(function (MessageSendResponseState) {
    MessageSendResponseState[MessageSendResponseState["OK"] = 0] = "OK";
    MessageSendResponseState[MessageSendResponseState["Large"] = 1] = "Large";
    MessageSendResponseState[MessageSendResponseState["Blank"] = 2] = "Blank";
    MessageSendResponseState[MessageSendResponseState["Other"] = 3] = "Other";
})(MessageSendResponseState = exports.MessageSendResponseState || (exports.MessageSendResponseState = {}));
var CreateAccountResponseState;
(function (CreateAccountResponseState) {
    CreateAccountResponseState[CreateAccountResponseState["OK"] = 0] = "OK";
    CreateAccountResponseState[CreateAccountResponseState["EmailExists"] = 1] = "EmailExists";
    CreateAccountResponseState[CreateAccountResponseState["UsernameTaken"] = 2] = "UsernameTaken";
    CreateAccountResponseState[CreateAccountResponseState["InvalidPassword"] = 3] = "InvalidPassword";
})(CreateAccountResponseState = exports.CreateAccountResponseState || (exports.CreateAccountResponseState = {}));
var CreateGuildResponseState;
(function (CreateGuildResponseState) {
    CreateGuildResponseState[CreateGuildResponseState["OK"] = 0] = "OK";
    CreateGuildResponseState[CreateGuildResponseState["InvalidName"] = 1] = "InvalidName";
    CreateGuildResponseState[CreateGuildResponseState["TooManyGuilds"] = 2] = "TooManyGuilds";
})(CreateGuildResponseState = exports.CreateGuildResponseState || (exports.CreateGuildResponseState = {}));
var TransferOwnershipResponseState;
(function (TransferOwnershipResponseState) {
    TransferOwnershipResponseState[TransferOwnershipResponseState["OK"] = 0] = "OK";
    TransferOwnershipResponseState[TransferOwnershipResponseState["DoesNotExist"] = 1] = "DoesNotExist";
    TransferOwnershipResponseState[TransferOwnershipResponseState["NoPermission"] = 2] = "NoPermission";
    TransferOwnershipResponseState[TransferOwnershipResponseState["NetOwnerNotInGuild"] = 3] = "NetOwnerNotInGuild";
})(TransferOwnershipResponseState = exports.TransferOwnershipResponseState || (exports.TransferOwnershipResponseState = {}));
var UpdateGuildResponseState;
(function (UpdateGuildResponseState) {
    UpdateGuildResponseState[UpdateGuildResponseState["OK"] = 0] = "OK";
    UpdateGuildResponseState[UpdateGuildResponseState["DoesNotExist"] = 1] = "DoesNotExist";
    UpdateGuildResponseState[UpdateGuildResponseState["NoPermission"] = 2] = "NoPermission";
})(UpdateGuildResponseState = exports.UpdateGuildResponseState || (exports.UpdateGuildResponseState = {}));
var DeleteGuildResponseState;
(function (DeleteGuildResponseState) {
    DeleteGuildResponseState[DeleteGuildResponseState["OK"] = 0] = "OK";
    DeleteGuildResponseState[DeleteGuildResponseState["DoesNotExist"] = 1] = "DoesNotExist";
    DeleteGuildResponseState[DeleteGuildResponseState["NoPermission"] = 2] = "NoPermission";
    DeleteGuildResponseState[DeleteGuildResponseState["CouldNotDelete"] = 3] = "CouldNotDelete";
})(DeleteGuildResponseState = exports.DeleteGuildResponseState || (exports.DeleteGuildResponseState = {}));
var GetGuildResponseState;
(function (GetGuildResponseState) {
    GetGuildResponseState[GetGuildResponseState["OK"] = 0] = "OK";
    GetGuildResponseState[GetGuildResponseState["DoesNotExist"] = 1] = "DoesNotExist";
    GetGuildResponseState[GetGuildResponseState["NotInGuild"] = 2] = "NotInGuild";
})(GetGuildResponseState = exports.GetGuildResponseState || (exports.GetGuildResponseState = {}));
var CreateChannelResponseState;
(function (CreateChannelResponseState) {
    CreateChannelResponseState[CreateChannelResponseState["OK"] = 0] = "OK";
    CreateChannelResponseState[CreateChannelResponseState["DoesNotExist"] = 1] = "DoesNotExist";
    CreateChannelResponseState[CreateChannelResponseState["NoPermission"] = 2] = "NoPermission";
    CreateChannelResponseState[CreateChannelResponseState["NotInGuild"] = 3] = "NotInGuild";
})(CreateChannelResponseState = exports.CreateChannelResponseState || (exports.CreateChannelResponseState = {}));
var GetChannelsResponseState;
(function (GetChannelsResponseState) {
    GetChannelsResponseState[GetChannelsResponseState["OK"] = 0] = "OK";
    GetChannelsResponseState[GetChannelsResponseState["DoesNotExist"] = 1] = "DoesNotExist";
    GetChannelsResponseState[GetChannelsResponseState["NotInGuild"] = 2] = "NotInGuild";
})(GetChannelsResponseState = exports.GetChannelsResponseState || (exports.GetChannelsResponseState = {}));
var GetMembersResponseState;
(function (GetMembersResponseState) {
    GetMembersResponseState[GetMembersResponseState["OK"] = 0] = "OK";
    GetMembersResponseState[GetMembersResponseState["InvalidRange"] = 1] = "InvalidRange";
    GetMembersResponseState[GetMembersResponseState["NotInGuild"] = 2] = "NotInGuild";
})(GetMembersResponseState = exports.GetMembersResponseState || (exports.GetMembersResponseState = {}));
var GetMemberResponseState;
(function (GetMemberResponseState) {
    GetMemberResponseState[GetMemberResponseState["OK"] = 0] = "OK";
    GetMemberResponseState[GetMemberResponseState["NotInGuild"] = 1] = "NotInGuild";
    GetMemberResponseState[GetMemberResponseState["InvalidMember"] = 2] = "InvalidMember";
})(GetMemberResponseState = exports.GetMemberResponseState || (exports.GetMemberResponseState = {}));
var UpdateMeResponseState;
(function (UpdateMeResponseState) {
    UpdateMeResponseState[UpdateMeResponseState["OK"] = 0] = "OK";
    UpdateMeResponseState[UpdateMeResponseState["InvalidChanges"] = 1] = "InvalidChanges";
})(UpdateMeResponseState = exports.UpdateMeResponseState || (exports.UpdateMeResponseState = {}));
var UseInviteResponseState;
(function (UseInviteResponseState) {
    UseInviteResponseState[UseInviteResponseState["OK"] = 0] = "OK";
    UseInviteResponseState[UseInviteResponseState["Invalid"] = 1] = "Invalid";
})(UseInviteResponseState = exports.UseInviteResponseState || (exports.UseInviteResponseState = {}));
var GetInviteResponseState;
(function (GetInviteResponseState) {
    GetInviteResponseState[GetInviteResponseState["OK"] = 0] = "OK";
    GetInviteResponseState[GetInviteResponseState["NoPermission"] = 1] = "NoPermission";
})(GetInviteResponseState = exports.GetInviteResponseState || (exports.GetInviteResponseState = {}));
function getPacketEventName(type) {
    if (NetworkPacketType[type] === undefined) {
        return "unknown";
    }
    const originalName = NetworkPacketType[type].toString();
    return originalName.charAt(0).toLowerCase() + originalName.slice(1);
}
exports.getPacketEventName = getPacketEventName;
exports.default = NetworkAction;
