"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getTimestamp(date) {
    let timestamp = "";
    let minutes = date.getMinutes();
    let hours = date.getHours();
    hours = hours % 12;
    hours = hours ? hours : 12;
    if (date.getDate() === new Date(Date.now()).getDate()) {
        timestamp = `Today at ${hours}:${('0' + minutes).slice(-2)} ${date.getHours() >= 12 ? 'PM' : 'AM'}`;
    }
    else if (date.getDay() + 1 === new Date(Date.now()).getDay()) {
        timestamp = `Yesterday at ${hours}:${('0' + minutes).slice(-2)} ${date.getHours() >= 12 ? 'PM' : 'AM'}`;
    }
    else if (getWeek(date) + 1 === getWeek(new Date(Date.now())) || new Date(Date.now()).getDate() - date.getDate() <= 7) {
        timestamp = `Last ${getDayName(date)} at ${hours}:${('0' + minutes).slice(-2)} ${date.getHours() >= 12 ? 'PM' : 'AM'}`;
    }
    else {
        timestamp = `${date.getMonth() + 1}/${date.getDate()}/${date.getFullYear()}`;
    }
    return timestamp;
}
exports.getTimestamp = getTimestamp;
let getDayName = function (date) {
    let days = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
    return days[date.getDay()];
};
let getWeek = function (date) {
    let d = new Date(Date.UTC(date.getFullYear(), date.getMonth(), date.getDate()));
    let dayNum = d.getUTCDay() || 7;
    d.setUTCDate(d.getUTCDate() + 4 - dayNum);
    let yearStart = new Date(Date.UTC(d.getUTCFullYear(), 0, 1));
    return Math.ceil((((d.getTime() - yearStart.getTime()) / 86400000) + 1) / 7);
};
